%define	major		0
%define libname		%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d
%define oversion 217

Summary:	Real-time MIDI input/output, audio I/O library
Name:		portmidi
Version:	20191230
Release:	%mkrel 4
License:	GPLv2
Group:		System/Libraries
URL:		http://portmedia.sourceforge.net
Source0:	http://downloads.sourceforge.net/portmedia/%{name}-src-%{oversion}.zip
Patch0:		portmidi-217-cmake-libdir-java-opts.patch
Patch1:		portmidi-217-cmake-CMP0037.patch
Patch2:		portmidi-217-portmidi_cmake.patch
Patch3:		portmidi-217-porttime_cmake.patch
Patch4:		portmidi-217-port-to-python3.patch
Patch5:     portmidi-cyrex-0.21.patch

BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(python3)
BuildRequires:	python3-cython
BuildRequires:	cmake



%description
PortMidi -- real-time MIDI input/output.

This package provides test applications that utilizes the shared portmidi and
porttime libraries.

 * portmidi-latency
 * portmidi-midithread
 * portmidi-midithru
 * portmidi-sysex
 * portmidi-test

%package -n	%{libname}
Summary:	Real-time MIDI input/output, audio I/O library
Group:		System/Libraries

Obsoletes: prboom
Obsoletes: prboom-plus
Obsoletes: prboom-gl
Obsoletes: prboom-server
Obsoletes: freedoom

%description -n	%{libname}
PortMidi -- real-time MIDI input/output.

This package provides the shared libraries for portmidi and porttime.

%package -n	%{develname}
Summary:	Development files for PortMidi
Group:		Development/Libraries
Requires:	%{libname} = %{version}-%{release}
Obsoletes:	%{name}-devel < %{version}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	porttime-devel = %{version}-%{release}

%description -n	%{develname}
PortMidi -- real-time MIDI input/output.

This package provides the development libraries and headers for portmidi and
porttime.

%package -n	python3-pyportmidi
Summary:	Python 3 wrapper for %{name}
Group:		Development/Python

%description -n	python3-pyportmidi
PyPortMidi is a Python 3 wrapper for PortMidi. PortMidi is a cross-platform
C library for realtime MIDI control. Using PyPortMidi, you can send and
receive MIDI data in realtime from Python.

%prep
%setup -q -n %{name}
%apply_patches

%build
%define Werror_cflags %nil
%cmake -DVERSION=%{version} \
       -DPORTMIDI_ENABLE_JAVA=OFF \
       -DCMAKE_CACHEFILE_DIR=`pwd` \
       -DCMAKE_BUILD_TYPE=Release
#parallel build is broken
%__make

# build python module
pushd ../pm_python
export CFLAGS="%{optflags} -I../pm_common -I../porttime -L../build/Release"
%{__python3} setup.py build
popd

%install
%make_install -C build

install -d %{buildroot}%{_bindir}
pushd build/Release
install -m0755 latency %{buildroot}%{_bindir}/portmidi-latency
install -m0755 midiclock %{buildroot}%{_bindir}/portmidi-midiclock
install -m0755 midithread %{buildroot}%{_bindir}/portmidi-midithread
install -m0755 midithru %{buildroot}%{_bindir}/portmidi-midithru
install -m0755 mm %{buildroot}%{_bindir}/portmidi-mm
install -m0755 qtest %{buildroot}%{_bindir}/portmidi-qtest
install -m0755 sysex %{buildroot}%{_bindir}/portmidi-sysex
install -m0755 test %{buildroot}%{_bindir}/portmidi-test
popd

# install python module
pushd pm_python
%py3_install
popd

%files
%{_bindir}/portmidi-latency
%{_bindir}/portmidi-midiclock
%{_bindir}/portmidi-midithread
%{_bindir}/portmidi-midithru
%{_bindir}/portmidi-mm
%{_bindir}/portmidi-qtest
%{_bindir}/portmidi-sysex
%{_bindir}/portmidi-test

%files -n %{libname}
%{_libdir}/lib%{name}.so.%{major}*
%{_libdir}/libporttime.so.%{major}*

%files -n %{develname}
%{_includedir}/%{name}.h
%{_includedir}/porttime.h
%{_libdir}/lib%{name}.so
%{_libdir}/libporttime.so

%files -n python3-pyportmidi
%{python3_sitearch}/pyportmidi/
%{python3_sitearch}/pyportmidi-0.0.7-py%{python3_version}.egg-info


%changelog
* Tue Aug 23 2022 tex - 20191230-4pclos2022
- rebuild against updates

* Tue Jun 21 2022 TerryN <terryn94 at gmail.com>  20191230-3pclos2022
- patch and rebuild for python 3.10

* Mon Dec 30 2019 tex - 20191230-2pclos2019
- rebuild
- update to 217

